# encoding: utf-8
# Code generated by Microsoft (R) AutoRest Code Generator 0.11.0.0
# Changes may cause incorrect behavior and will be lost if the code is
# regenerated.

module Azure::ARM::Network
  module Models
    #
    # Properties of IPConfiguration
    #
    class NetworkInterfaceIpConfigurationPropertiesFormat

      include MsRestAzure

      # @return [String] Gets or sets the privateIPAddress of the Network
      # Interface IP Configuration
      attr_accessor :private_ipaddress

      # @return [IpAllocationMethod] Gets or sets PrivateIP allocation method
      # (Static/Dynamic). Possible values for this property include:
      # 'Static', 'Dynamic'.
      attr_accessor :private_ipallocation_method

      # @return [SubResource] Gets or sets the reference of the subnet resource
      attr_accessor :subnet

      # @return [SubResource] Gets or sets the reference of the PublicIP
      # resource
      attr_accessor :public_ipaddress

      # @return [Array<SubResource>] Gets or sets the reference of
      # LoadBalancerBackendAddressPool resource
      attr_accessor :load_balancer_backend_address_pools

      # @return [Array<SubResource>] Gets or sets list of references of
      # LoadBalancerInboundNatRules
      attr_accessor :load_balancer_inbound_nat_rules

      # @return [String] Gets or sets Provisioning state of the PublicIP
      # resource Updating/Deleting/Failed
      attr_accessor :provisioning_state

      #
      # Validate the object. Throws ValidationError if validation fails.
      #
      def validate
        @subnet.validate unless @subnet.nil?
        @public_ipaddress.validate unless @public_ipaddress.nil?
        @load_balancer_backend_address_pools.each{ |e| e.validate if e.respond_to?(:validate) } unless @load_balancer_backend_address_pools.nil?
        @load_balancer_inbound_nat_rules.each{ |e| e.validate if e.respond_to?(:validate) } unless @load_balancer_inbound_nat_rules.nil?
      end

      #
      # Serializes given Model object into Ruby Hash.
      # @param object Model object to serialize.
      # @return [Hash] Serialized object in form of Ruby Hash.
      #
      def self.serialize_object(object)
        object.validate
        output_object = {}

        serialized_property = object.private_ipaddress
        output_object['privateIPAddress'] = serialized_property unless serialized_property.nil?

        serialized_property = object.private_ipallocation_method
        output_object['privateIPAllocationMethod'] = serialized_property unless serialized_property.nil?

        serialized_property = object.subnet
        unless serialized_property.nil?
          serialized_property = SubResource.serialize_object(serialized_property)
        end
        output_object['subnet'] = serialized_property unless serialized_property.nil?

        serialized_property = object.public_ipaddress
        unless serialized_property.nil?
          serialized_property = SubResource.serialize_object(serialized_property)
        end
        output_object['publicIPAddress'] = serialized_property unless serialized_property.nil?

        serialized_property = object.load_balancer_backend_address_pools
        unless serialized_property.nil?
          serializedArray = []
          serialized_property.each do |element|
            unless element.nil?
              element = SubResource.serialize_object(element)
            end
            serializedArray.push(element)
          end
          serialized_property = serializedArray
        end
        output_object['loadBalancerBackendAddressPools'] = serialized_property unless serialized_property.nil?

        serialized_property = object.load_balancer_inbound_nat_rules
        unless serialized_property.nil?
          serializedArray = []
          serialized_property.each do |element1|
            unless element1.nil?
              element1 = SubResource.serialize_object(element1)
            end
            serializedArray.push(element1)
          end
          serialized_property = serializedArray
        end
        output_object['loadBalancerInboundNatRules'] = serialized_property unless serialized_property.nil?

        serialized_property = object.provisioning_state
        output_object['provisioningState'] = serialized_property unless serialized_property.nil?

        output_object
      end

      #
      # Deserializes given Ruby Hash into Model object.
      # @param object [Hash] Ruby Hash object to deserialize.
      # @return [NetworkInterfaceIpConfigurationPropertiesFormat] Deserialized
      # object.
      #
      def self.deserialize_object(object)
        return if object.nil?
        output_object = NetworkInterfaceIpConfigurationPropertiesFormat.new

        deserialized_property = object['privateIPAddress']
        output_object.private_ipaddress = deserialized_property

        deserialized_property = object['privateIPAllocationMethod']
        if (!deserialized_property.nil? && !deserialized_property.empty?)
          enum_is_valid = IpAllocationMethod.constants.any? { |e| IpAllocationMethod.const_get(e).to_s.downcase == deserialized_property.downcase }
          fail MsRest::DeserializationError.new('Error occured while deserializing the enum', nil, nil, nil) unless enum_is_valid
        end
        output_object.private_ipallocation_method = deserialized_property

        deserialized_property = object['subnet']
        unless deserialized_property.nil?
          deserialized_property = SubResource.deserialize_object(deserialized_property)
        end
        output_object.subnet = deserialized_property

        deserialized_property = object['publicIPAddress']
        unless deserialized_property.nil?
          deserialized_property = SubResource.deserialize_object(deserialized_property)
        end
        output_object.public_ipaddress = deserialized_property

        deserialized_property = object['loadBalancerBackendAddressPools']
        unless deserialized_property.nil?
          deserializedArray = [];
          deserialized_property.each do |element2|
            unless element2.nil?
              element2 = SubResource.deserialize_object(element2)
            end
            deserializedArray.push(element2);
          end
          deserialized_property = deserializedArray;
        end
        output_object.load_balancer_backend_address_pools = deserialized_property

        deserialized_property = object['loadBalancerInboundNatRules']
        unless deserialized_property.nil?
          deserializedArray = [];
          deserialized_property.each do |element3|
            unless element3.nil?
              element3 = SubResource.deserialize_object(element3)
            end
            deserializedArray.push(element3);
          end
          deserialized_property = deserializedArray;
        end
        output_object.load_balancer_inbound_nat_rules = deserialized_property

        deserialized_property = object['provisioningState']
        output_object.provisioning_state = deserialized_property

        output_object.validate

        output_object
      end
    end
  end
end
